\chapter{Modbat}
After working for one month in RISEC, we manage to have the first results.
 This is also the chance to explain more in detail how Modbat works.

	\section{Scala}
In order to use Modbat, we must create the model that will be tested first.
 In order to create this model we use the language Scala.

Scala is an object-functional programming and scripting language for general software applications.
 Scala has full support for functional programming and a very strong static type system.
 This allows programs written in Scala to be very concise and thus smaller in size than most general purpose programming languages.
 Many of Scala's design decisions were inspired by criticism over the shortcomings of Java.

Scala source code is intended to be compiled to Java byte-code,
 so that the resulting executable code runs on a Java virtual machine.
 Java libraries may be used directly in Scala code, and vice versa.
 Like Java, Scala is statically typed and object-oriented, and uses a curly-brace syntax reminiscent of the C programming language.
 The name Scala is a portmanteau of "scalable" and "language", signifying that it is designed to grow with the demands of its users.

	\section{A use of Modbat}
We consider this example:  a simple system that after an initialization can perform a main action as many time as it wants before quitting.
 It can also perform a second action but only once before quitting. This model can be shown with the figure 2.1.

\begin{figure}[!h]
\centering
\includegraphics[scale=0.75]{image/ChapterModBat/ModbatExample.pdf}
\caption{Example of a model with ZooKeeper}
\end{figure}

With Scala we create an instance of Modbat and we will have something as following:
\begin{listing}[1]{1}
def instance() = {
  new MBT (
    "initialization" -> "mainAction" := { //start the model },
    "mainAction" -> "mainAction" := { //do something },
    "mainAction" -> "secondAction" := { //do something },
    "mainAction" -> "quit" := { //do something },
    "secondAction" -> "quit" := { //do something },
    "quit" -> "end"
  )
}
\end{listing}

From this model, we can perform as many tests as we want, Modbat when several actions are possible,
 choose randomly one action to perform. A lot of options can be added to the model,
 indeed some action can have some requirement to be performed,
 or we can also add some assertion to check this model and that there is no mistake.
 A lot of other options are also available to handle particular cases.

	\section{Some results with Modbat}
I use Modbat for the first time Modbat and the language Scala with the modelling of list.
 After one week I have created a model more complex with a simple server that handle several clients.

		\subsection{list}
We used deliberately a defective library of the list that behave like the library of Java,
 these dysfunctions are known and allow to test if Modbat is really useful.
 And for us it is the better way to get familiar with the software,
 because we can use the Java library to check our model.
 Indeed we can postulate that, with all the test perform by a lot of people before,
 the library of Java is correct with no bug.
 So if our model do not found a mistake with the Java library, but with the other model there is one,
 we can be sure that our model is correct and we found a real bug.

The library contains a lot of kind of list, I create the model of these list:
 Array, HashSet, TreeSet, HashSet, TreeMap, HashMap, LinkedList, Stack.
 The model of a list is really simple,
 it has only one state and a lot of transition to this same test.

At the end I quickly found a lot of mistakes with Modbat that confirm the utility of this tool.

		\subsection{channel}
After one week, I start to create a more complex model.
 For this model I had to use another functionality of Modbat,
 here we have two different model that work together:
 the model of the server, and the model of the client.
 The server will act as the main model that once started,
 will launch as many client that it wants.

For this model, I did not find any bug. But it was useful to really learn how use all the options of Modbat and learn more in detail Scala.

			\subsubsection{the client}
The model of the client is very simple and will just perform some writing and reading action before closing his connection.
 In reality this model is far more complex and some features as the rights to read or write by the client are not shown on this figure.

\begin{figure}[!h]
\centering
\includegraphics[scale=0.75]{image/ChapterModBat/JavanioClientModel.pdf}
\caption{Model of the client}
\end{figure}
			\subsubsection{the server}
Once the channel is bound and the port set, it will try to launch several clients,
 or can also be closed directly. the launch of the client is not show, but once the state "selector" reach,
 if the client can be connected, with the loop selector -> connected -> selector,
 an instance of the client model will be launch and act independently of the server model.

\begin{figure}[!h]
\centering
\includegraphics[scale=0.75]{image/ChapterModBat/JavanioServerModel.pdf}
\caption{Model of the server}
\end{figure}